#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 LawnGreen
#property indicator_color2 Red

extern int Price = PRICE_CLOSE;

extern int BB_Period =20;
extern int BB_Price = PRICE_CLOSE;
extern int BB_Dev = 2;
extern int BB_Type = MODE_SMA;

extern int RSI_Period =20;
extern int RSI_Price = PRICE_CLOSE;

extern int MOM_Period =20;
extern int MOM_Price = PRICE_CLOSE;

extern int MON_Period =20;

extern int STOK_Period= 8;
extern int STOD_Period=3;
extern int STO_Slow=3;
extern int STO_Method=MODE_SMA;
extern int STO_Price=PRICE_CLOSE;

double CrossUp[];
double CrossDown[];
double state[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0, CrossUp);   SetIndexStyle(0, DRAW_ARROW); SetIndexArrow(0, 225);
   SetIndexBuffer(1, CrossDown); SetIndexStyle(1, DRAW_ARROW); SetIndexArrow(1, 226);
   SetIndexBuffer(2, state);
  return(0);
}

//+------------------------------------------------------------------+
//| script program start function |
//+------------------------------------------------------------------+
int start()
{
  int counted_bars = IndicatorCounted();
  if(counted_bars < 0)   return(-1);
  if(counted_bars > 0)   counted_bars--;
      int limit = MathMin(Bars - counted_bars,Bars-1);
  for(int i=limit; i>0; i--)
  {
    double BBUp  = iBands(Symbol(),0,BB_Period,BB_Dev,0,BB_Price,MODE_UPPER,i);
    double BBDw  = iBands(Symbol(),0,BB_Period,BB_Dev,0,BB_Price,MODE_LOWER,i);
    double RSI   = iRSI(Symbol(),0,RSI_Period,RSI_Price,i);
    double MOM   = iMomentum(Symbol(),0,MOM_Period,MOM_Price,i);
    double MON   = iMFI(Symbol(),0,MON_Period,i);
    double STOUp = iStochastic(Symbol(),0,STOK_Period,STOD_Period,STO_Slow,STO_Method,STO_Price,0,i);
    double STODw = iStochastic(Symbol(),0,STOK_Period,STOD_Period,STO_Slow,STO_Method,STO_Price,1,i);
    double price = iMA(NULL,0,1,0,MODE_SMA,Price,i);

    CrossUp[i]   = EMPTY_VALUE;
    CrossDown[i] = EMPTY_VALUE;
    state[i]     = state[i+1];
    if (price >= BBUp && RSI <= 30 && MOM <= 30 && MON <= 20 && STOUp <= 20 && STODw <= 20 && state[i]!=1)
    {
      state[i]   = 1;
      CrossUp[i] = Low[i] - iATR(NULL,0,10,i);
      Comment("up "+TimeToStr(Time[i],TIME_DATE|TIME_SECONDS)+" "+DoubleToStr(CrossUp[i],5));
    } 
    if (price <= BBDw && RSI <= 70 && MOM >= 70 && MON >= 80 && STOUp >= 80 && STODw >= 80 && state[i]!=-1)
    {
      state[i]   = -1;
      CrossDown[i]=High[i] + iATR(NULL,0,10,i); 
      Comment("down "+TimeToStr(Time[i],TIME_DATE|TIME_SECONDS)+" "+DoubleToStr(CrossDown[i],5));
    }
  }
  return(0);
}  